;L4.ASM  17.11.98 - ELEKTRO-PIC VODIC

;koriscenje rezervnih imena, imena bitova i uslovnih petlji

#DEFINE PAGE0 bcf STATUS,5
#DEFINE PAGE1 bsf STATUS,5
        .AVSYM

STATUS: .EQU $03        ;STATUS registar
TRISB:  .EQU $06        ;registar smera podataka porta B
PORTB:  .EQU $06        ;registar podataka porta B 
W:      .EQU 0          ;fleg radnog registra
F:      .EQU 1          ;fleg fajl registra
C:      .EQU 0          ;Carry fleg
	movlw 8
	movlw 8
	movlw 8
	movlw 8
        .ORG 4          ;adresa interapt vektora
	goto prekid
        .ORG 5          ;pocetak programske memorije
	nop
	PAGE1
	movlw 8
	.ORG 20
	movwf $1
	PAGE0	 
	.ORG 50
	movlw $B0
	movwf $B
        clrf PORTB      ;brisanje registra podataka porta B
        PAGE1           ;PAGE1
        clrf TRISB      ;registar smera podataka porta B kao izlazni
        PAGE0           ;PAGE0

LOOP1:  movlw 1         ;ucitati vrednost 1 u radni registar
        movwf PORTB     ;ucitati ovu vrednost kao podatak u port B
        bcf STATUS,C    ;brisati Carry fleg

LOOP2:  rlf PORTB,F     ;rotirati vrednost PORTB na levo za jedno logicko mesto
        btfss STATUS,C  ;proveriti da li je Carry fleg setovan
        goto LOOP2      ;ova komanda deluje samo ako PORTB jos uvek nije setovan na 0
                        ;program skace nazad na adresu LOOP2
        goto LOOP1      ;ova komanda deluje samo onda kada je PORTB = 0
	nop
prekid:	nop
	retfie
        .END            ;komanda za kraj

