;L10.ASM  26.11.98 - ELEKTRO-PIC VODIC

;upotreba jednog prekidaca na portu A za povecanje broja koji se prikazuje preko LED na portu B
;pokazuje kako se testiranje bita moze iskoristiti za testiranje statusa prekidaca
;i dovodi do povecanja broja samo u trenutku kada je pritisnut prekidaca

#DEFINE PAGE0 bcf STATUS,5
#DEFINE PAGE1 bsf STATUS,5

STATUS: .EQU $03        ;
TRISB:  .EQU $06        ;
PORTB:  .EQU $06        ;
W:      .EQU 0          ;
F:      .EQU 1          ;

TRISA:  .EQU $05        ;
PORTA:  .EQU $05        ;
COUNT:  .EQU $0C        ;
SWITCH: .EQU $0D        ;promenljiva koja cuva prethodni status prekidaca

        .ORG 4          ;
        .ORG 5          ;

        clrf PORTB      ;
        PAGE1           ;
        movlw 1         ;
        movwf TRISA     ;
        clrf TRISB      ;
        PAGE0           ;

BEGIN:  clrf COUNT      ;
        clrf SWITCH     ;

TESTIT: btfsc PORTA,0   ;testira bit 0 porta A, da li je =0?
        goto TSTPRV     ;ne, onda je = 1, zato idi na TSTPRV
        bcf SWITCH,0    ;brise se bit bit 0 SWITCH registra
        goto TESTIT     ;skok nazad na TESTIT
TSTPRV: btfsc SWITCH,0  ;testira bit 0 SWITCH registra, da li je =0?
        goto TESTIT     ;ne, onda je = 1, zato idi na TESTIT
        incf COUNT,F    ;da, onda je = 0, zato povecati broj za 1
        movf COUNT,W    ;uzeti vrednost COUNT
        movwf PORTB     ;prebaciti je u PORTB
        bsf SWITCH,0    ;setovati bit 0 SWITCH registra
        goto TESTIT     ;ponoviti

        .END            ;komanda za kraj

